View Issue Details

IDProjectCategoryView StatusLast Update
0028508Open CASCADEOCCT:Modeling Algorithmspublic2017-09-29 16:25
Reporteremv Assigned Tobugmaster  
PrioritynormalSeverityminor 
Status closedResolutionfixed 
Product Version7.1.0 
Target Version7.2.0Fixed in Version7.2.0 
Summary0028508: Make the CellsBuilder algorithm to work with multi-dimensional arguments
DescriptionCurrently, the Cells Builder algorithm supports only the arguments of the same type (only SOLIDs or only FACEs for example). The issue is to extend this algorithm to multi-dimensional mode.
Steps To Reproducebox b 10 10 10
plane p 5 5 5 1 0 0
mkface f p -10 10 -10 10
bclearobjects
bcleartools
baddobjects b f
bfillds
bcbuild rx
bcadd result b 1
checknbshapes result -solid 2

testgrid boolean cells_test
TagsNo tags attached.
Test case numberboolean cells_test J1, J2, J3, J4, J5, J6

Relationships

related to 0028179 closedbugmaster Update documentation of Boolean Component 

Activities

git

2017-03-16 14:06

administrator   ~0064379

Branch CR28508 has been created by emv.

SHA-1: 5e8e6a608fb222ed1693fd6d9fc2af2ad87de8ed


Detailed log of new commits:

Author: emv
Date: Fri Mar 10 15:13:48 2017 +0300

    0028508: Make the CellsBuilder algorithm to work with multi-dimensional arguments
    
    1. The CellsBuilder algorithm has been extended to work with multi-dimensional arguments.
    It has become possible not only simulate Boolean expressions, but also perform non-supported
    Boolean operations, like cutting face from solid, or fusing face with edge.
    
    2. Test cases with multi-dimensional input shapes have been created.
    
    3. Documentation has been updated.

emv

2017-03-16 14:07

developer   ~0064380

Dear Mikhail, could you please review the git branch CR28508?

msv

2017-03-20 16:16

developer   ~0064537

Remarks:

src\BOPAlgo\BOPAlgo_CellsBuilder.hxx
- 106: misprint "Waring"
- rename enum BOPAlgo_CellsBuilder_WarningStatusEnum into WarningStatus, and make it public.
- Replace word 'unification' with 'remove internal boundaries'
- make enum items more short, and revise their content and meaning.
- RemoveInternalBoundaries is the only method setting warning status. It should be reflected in description of the class.
- 145: add comment that this code is not needed if bUpdate is true.

src\BOPAlgo\BOPAlgo_CellsBuilder.cxx
- 791: extra words "should be created".
- accept output stream in DumpWarnings().

src\BOPTest\BOPTest_CellsCommands.cxx
- put warning statuses to "di".

dox\user_guides\boolean_operations\boolean_operations.md
- 2295: "impossible from Booleans point of view" => "impossible using standard Boolean fuse operation".

git

2017-03-20 16:19

administrator   ~0064538

Branch CR28508 has been updated forcibly by emv.

SHA-1: 40fe0323d0565d41ccb2220ffe81a06e1f1f16bc

emv

2017-03-20 16:20

developer   ~0064539

The git branch CR28508 has been rebased on current master.

git

2017-03-21 10:44

administrator   ~0064569

Branch CR28508_1 has been created by emv.

SHA-1: 61a41fdf748f5457ff946b70098874673ba2e1bc


Detailed log of new commits:

Author: emv
Date: Fri Mar 10 15:13:48 2017 +0300

    0028508: Make the CellsBuilder algorithm to work with multi-dimensional arguments
    
    1. The CellsBuilder algorithm has been extended to work with multi-dimensional arguments.
    It has become possible not only simulate Boolean expressions, but also perform non-supported
    Boolean operations, like cutting face from solid, or fusing face with edge.
    
    2. Test cases with multi-dimensional input shapes have been created.
    
    3. Documentation has been updated.

emv

2017-03-21 10:46

developer   ~0064570

The remarks have been considered. Please review the git branch CR28508_1.

msv

2017-03-21 11:45

developer   ~0064575

Reviewed.

mkv

2017-03-22 15:47

tester   ~0064620

Last edited: 2017-03-22 15:50

Dear BugMaster,
Branch CR28508_1 from occt git-repository (and master from products git-repository) was compiled on Linux, MacOS and Windows platforms and tested on Release mode.
SHA-1: 61a41fdf748f5457ff946b70098874673ba2e1bc

Number of compiler warnings:

occt component :
Linux: 0 (0 on master)
Windows: 0 (0 on master)
MacOS : 0 (0 on master)

products component :
Linux: 64 (64 on master)
Windows: 0 (0 on master)
MacOS : 1198

Regressions/Differences/Improvements:
No regressions/differences

Testing cases:
http://occt-tests/CR28508_1-master-OCCT/Debian70-64/boolean/cells_test/J1.html
http://occt-tests/CR28508_1-master-OCCT/Windows-64-VC10/boolean/cells_test/J1.html
boolean cells_test J1: OK
http://occt-tests/CR28508_1-master-OCCT/Debian70-64/boolean/cells_test/J2.html
http://occt-tests/CR28508_1-master-OCCT/Windows-64-VC10/boolean/cells_test/J2.html
boolean cells_test J2: OK
http://occt-tests/CR28508_1-master-OCCT/Debian70-64/boolean/cells_test/J3.html
http://occt-tests/CR28508_1-master-OCCT/Windows-64-VC10/boolean/cells_test/J3.html
boolean cells_test J3: OK
http://occt-tests/CR28508_1-master-OCCT/Debian70-64/boolean/cells_test/J4.html
http://occt-tests/CR28508_1-master-OCCT/Windows-64-VC10/boolean/cells_test/J4.html
boolean cells_test J4: OK
http://occt-tests/CR28508_1-master-OCCT/Debian70-64/boolean/cells_test/J5.html
http://occt-tests/CR28508_1-master-OCCT/Windows-64-VC10/boolean/cells_test/J5.html
boolean cells_test J5: OK
http://occt-tests/CR28508_1-master-OCCT/Debian70-64/boolean/cells_test/J6.html
http://occt-tests/CR28508_1-master-OCCT/Windows-64-VC10/boolean/cells_test/J6.html
boolean cells_test J6: OK

Testing on Linux:
occt component :
Total MEMORY difference: 92192314 / 92032328 [+0.17%]
Total CPU difference: 20148.03000000014 / 20187.16000000011 [-0.19%]
products component :
Total MEMORY difference: 31030037 / 31146794 [-0.37%]
Total CPU difference: 5468.999999999987 / 5412.149999999975 [+1.05%]
Testing on Windows:
occt component :
Total MEMORY difference: 57783854 / 57782265 [+0.00%]
Total CPU difference: 18883.53104749858 / 18782.551600198512 [+0.54%]
products component :
Total MEMORY difference: 22292937 / 22254740 [+0.17%]
Total CPU difference: 5417.587127899969 / 5421.409152399973 [-0.07%]

There are no differences in images found by testdiff.

mkv

2017-03-22 15:48

tester   ~0064621

Dear BugMaster,
Branch CR28508_1 is TESTED.

git

2017-03-23 14:08

administrator   ~0064646

Branch CR28508_2 has been created by emv.

SHA-1: 973bb448b17452705ed26acafa10034582ffee73


Detailed log of new commits:

Author: emv
Date: Fri Mar 10 15:13:48 2017 +0300

    0028508: Make the CellsBuilder algorithm to work with multi-dimensional arguments
    
    1. The CellsBuilder algorithm has been extended to work with multi-dimensional arguments.
    It has become possible not only simulate Boolean expressions, but also perform non-supported
    Boolean operations, like cutting face from solid, or fusing face with edge.
    
    2. Test cases with multi-dimensional input shapes have been created.
    
    3. Documentation has been updated.

git

2017-03-24 13:47

administrator   ~0064685

Branch CR28508_2 has been updated by emv.

SHA-1: f122a90d439ce357581bb327ea20b22bf96eded3


Detailed log of new commits:

Author: emv
Date: Fri Mar 24 13:44:11 2017 +0300

    // Eliminating warnings.

git

2017-05-12 11:35

administrator   ~0065916

Branch CR28508 has been deleted by kgv.

SHA-1: 40fe0323d0565d41ccb2220ffe81a06e1f1f16bc

git

2017-05-12 11:35

administrator   ~0065917

Branch CR28508_1 has been deleted by kgv.

SHA-1: 61a41fdf748f5457ff946b70098874673ba2e1bc

git

2017-05-12 11:35

administrator   ~0065918

Branch CR28508_2 has been deleted by kgv.

SHA-1: f122a90d439ce357581bb327ea20b22bf96eded3

Related Changesets

occt: master e8b9db57

2017-03-10 12:13:48

emv


Committer: bugmaster Details Diff
0028508: Make the CellsBuilder algorithm to work with multi-dimensional arguments

1. The CellsBuilder algorithm has been extended to work with multi-dimensional arguments.
It has become possible not only simulate Boolean expressions, but also perform non-supported
Boolean operations, like cutting face from solid, or fusing face with edge.

2. Test cases with multi-dimensional input shapes have been created.

3. Documentation has been updated.
Affected Issues
0028508
mod - dox/user_guides/boolean_operations/boolean_operations.md Diff File
add - dox/user_guides/boolean_operations/images/cells_algorithm_001.png Diff File
add - dox/user_guides/boolean_operations/images/cells_algorithm_002.png Diff File
add - dox/user_guides/boolean_operations/images/cells_algorithm_003.png Diff File
add - dox/user_guides/boolean_operations/images/cells_algorithm_004.png Diff File
add - dox/user_guides/boolean_operations/images/cells_algorithm_005.png Diff File
add - dox/user_guides/boolean_operations/images/cells_algorithm_006_1.png Diff File
add - dox/user_guides/boolean_operations/images/cells_algorithm_006_2.png Diff File
add - dox/user_guides/boolean_operations/images/cells_algorithm_007.png Diff File
add - dox/user_guides/boolean_operations/images/cells_algorithm_008.png Diff File
mod - src/BOPAlgo/BOPAlgo_CellsBuilder.cxx Diff File
mod - src/BOPAlgo/BOPAlgo_CellsBuilder.hxx Diff File
mod - src/BOPTest/BOPTest_CellsCommands.cxx Diff File
add - tests/boolean/cells_test/J1 Diff File
add - tests/boolean/cells_test/J2 Diff File
add - tests/boolean/cells_test/J3 Diff File
add - tests/boolean/cells_test/J4 Diff File
add - tests/boolean/cells_test/J5 Diff File
add - tests/boolean/cells_test/J6 Diff File

Issue History

Date Modified Username Field Change
2017-03-06 13:06 emv New Issue
2017-03-06 13:06 emv Assigned To => msv
2017-03-06 13:07 emv Assigned To msv => emv
2017-03-06 13:07 emv Status new => assigned
2017-03-06 13:07 emv Summary Making CellsBuilder algorithm multi-dimensional => Make the CellsBuilder algorithm to work with multi-dimensional arguments
2017-03-06 13:07 emv Description Updated
2017-03-06 13:07 emv Description Updated
2017-03-16 14:06 git Note Added: 0064379
2017-03-16 14:07 emv Note Added: 0064380
2017-03-16 14:07 emv Assigned To emv => msv
2017-03-16 14:07 emv Status assigned => resolved
2017-03-16 14:07 emv Steps to Reproduce Updated
2017-03-20 16:16 msv Note Added: 0064537
2017-03-20 16:16 msv Assigned To msv => emv
2017-03-20 16:16 msv Status resolved => assigned
2017-03-20 16:19 git Note Added: 0064538
2017-03-20 16:20 emv Note Added: 0064539
2017-03-21 10:44 git Note Added: 0064569
2017-03-21 10:46 emv Note Added: 0064570
2017-03-21 10:46 emv Assigned To emv => msv
2017-03-21 10:46 emv Status assigned => resolved
2017-03-21 11:45 msv Note Added: 0064575
2017-03-21 11:45 msv Assigned To msv => bugmaster
2017-03-21 11:45 msv Status resolved => reviewed
2017-03-21 15:08 apv Assigned To bugmaster => mkv
2017-03-22 15:47 mkv Note Added: 0064620
2017-03-22 15:48 mkv Note Added: 0064621
2017-03-22 15:48 mkv Assigned To mkv => bugmaster
2017-03-22 15:48 mkv Status reviewed => tested
2017-03-22 15:48 mkv Test case number => boolean cells_test J1, J2, J3, J4, J5, J6
2017-03-22 15:50 mkv Note Edited: 0064620
2017-03-23 14:08 git Note Added: 0064646
2017-03-24 13:47 git Note Added: 0064685
2017-03-24 15:53 bugmaster Changeset attached => occt master e8b9db57
2017-03-24 15:53 bugmaster Status tested => verified
2017-03-24 15:53 bugmaster Resolution open => fixed
2017-04-05 08:00 emv Relationship added related to 0028179
2017-05-12 11:35 git Note Added: 0065916
2017-05-12 11:35 git Note Added: 0065917
2017-05-12 11:35 git Note Added: 0065918
2017-09-29 16:20 aiv Fixed in Version => 7.2.0
2017-09-29 16:25 aiv Status verified => closed